---
title: DOMMatrixReadOnly.scale()
slug: Web/API/DOMMatrixReadOnly/scale
tags:
  - API
  - DOMMatrix
  - DOMMatrixReadOnly
  - Experimental
  - Geometry
  - Geometry Interfaces
  - Interface
  - Method
  - Reference
  - Scale
  - matrix
---
<article class="text-content" id="wikiArticle">
<p>{{APIRef("Geometry Interfaces")}}{{seecompattable}}</p>

<p>The <strong><code>scale()</code></strong> method of the {{domxref("DOMMatrixReadOnly")}} interface creates a new matrix being the result of the original matrix with a scale transform applied.</p>

<h2 id="Syntax">Syntax</h2>

<p>The <code>scale()</code> method is specified with either one or six values.</p>

<pre class="syntaxbox">DOMMatrix.scale(<em>scaleX</em>[, <em>scaleY</em>][, <em>scaleZ][, originX</em>][, <em>originY</em>][, <em>originZ</em>])</pre>

<h3 class="highlight-spanned" id="Parameters"><span class="highlight-span">Parameters</span></h3>

<dl>
 <dt>scaleX</dt>
 <dd>A multiplier for the scale value on the x-axis.</dd>
 <dt>scaleY <span class="inlineIndicator optional optionalInline">Optional</span></dt>
 <dd>A multiplier for the scale value on the y-axis.  If not supplied, this defaults to the value of <code>scaleX</code>.</dd>
 <dt>scaleZ <span class="inlineIndicator optional optionalInline">Optional</span></dt>
 <dd>A multiplier for the scale value on the z-axis.  If this value is anything other than 1, the resulting matrix will be 3D.</dd>
 <dt>originX <span class="inlineIndicator optional optionalInline">Optional</span></dt>
 <dd>An x-coordinate for the origin of the transformation.  If no origin is supplied, this defaults to 0.</dd>
 <dt>originY <span class="inlineIndicator optional optionalInline">Optional</span></dt>
 <dd>A y-coordinate for the origin of the transformation.  If no origin is supplied, this defaults to 0.</dd>
 <dt>originZ <span class="inlineIndicator optional optionalInline">Optional</span></dt>
 <dd>A z-coordinate for the origin of the transformation.  If no origin is supplied, this defaults to 0. If this value is anything other than 0, the resulting matrix will be 3D.</dd>
</dl>

<h3 class="highlight-spanned" id="Return_value"><span class="highlight-span">Return value</span></h3>

<p>Returns a <a href="/en-US/docs/Web/API/DOMMatrix" title="The DOMMatrix interface represents 4x4 matrices, suitable for 2D and 3D operations."><code>DOMMatrix</code></a> containing a new matrix being the result of the matrix x and y dimensions being scaled by the given factor, centered on the origin given. The original matrix is not modified.</p>

<p>If a scale is applied about the z-axis, the resulting matrix will be a 4x4 3D matrix.</p>

<div class="notecard note">
<p><strong>Note</strong>: At time of writing, Firefox still supports an older version of the specification that accepts either one or three values.</p>

<pre>DOMMatrix.scale(scale[, originX][, originY])</pre>

<p>We'll show an example of how you can deal with the cross-browser support implications of this in the Examples section, below.</p>
</div>

<h2 id="Examples">Examples</h2>

<p>This SVG contains three squares, one red, one blue, and one green, each positioned at the document origin:</p>

<pre class="brush: html">&lt;svg width="250" height="250" viewBox="0 0 25 25"&gt;
  &lt;rect width="25" height="25" fill="red" /&gt;
  &lt;rect id="transformed" width="25" height="25" fill="blue" /&gt;
  &lt;rect id="transformedOrigin" width="25" height="25" fill="green" /&gt;
&lt;/svg&gt;</pre>

<p>This JavaScript first creates an identity matrix, then uses the <code>scale()</code> method to create a new matrix with a single parameter. </p>

<p>We test if the browser supports a six parameter <code>scale()</code> method by creating a new matrix using three parameters and observing it's <code>is2D</code> property — if this is <code>false</code> then the third parameter has been accepted by the browser as a <code>scaleZ</code> parameter, making this a 3D matrix.</p>

<p>We then create a new matrix scaled about a given origin, using either three or six parameters depending on the browser support.</p>

<p>These new matrices are then applied to the blue and green squares as a <code>transform</code>, changing their dimensions and position. The red square is left in place.</p>

<pre class="brush: js">const matrix = new DOMMatrixReadOnly();
const scaledMatrix = matrix.scale(0.5);

let scaledMatrixWithOrigin = matrix.scale(0.5, 25, 25);

// if the browser has interpreted these parameters as scaleX, scaleY, scaleZ, the resulting matrix is 3D
const browserExpectsSixParamScale = !scaledMatrixWithOrigin.is2D;
if (browserExpectsSixParamScale) {
  scaledMatrixWithOrigin = matrix.scale(0.5, 0.5, 1, 25, 25, 0);
}

document.querySelector('#transformed').setAttribute('transform', scaledMatrix.toString());
document.querySelector('#transformedOrigin').setAttribute('transform', scaledMatrixWithOrigin.toString());</pre>

<p>{{ EmbedLiveSample('Examples', '250', '250', 'https://mdn.mozillademos.org/files/16524/Screen_Shot_2019-02-18_at_13.23.31.png', 'Web/API/DOMMatrixReadOnly/scale') }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('Geometry Interfaces', '#dom-dommatrixreadonly-scale', 'DOMMatrixReadOnly.scale()') }}</td>
   <td>{{ Spec2('Geometry Interfaces') }}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DOMMatrixReadOnly.scale")}}</p>
</article>
